#include "soc/soc.h"
#include "soc/rtc_cntl_reg.h"
#include "WiFi.h" 
#include "driver/adc.h"
#include <esp_wifi.h>
#include <esp_bt.h>
#include <IRremote.h>
int RECV_PIN = 15;
int PG_PIN=27;
int powergood=0;
int pre_powergood=99;
int pg_count[2];
IRrecv irrecv(RECV_PIN);
IRsend irsend;
decode_results results;



void setup() {
  // put your setup code here, to run once:
 WRITE_PERI_REG(RTC_CNTL_BROWN_OUT_REG, 0); //disable brownout detector
 setCpuFrequencyMhz(80);
 WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
  btStop();
pinMode(2,OUTPUT);
pinMode(2,HIGH);

pinMode(PG_PIN, INPUT_PULLUP );
  Serial.begin(115200);
      Serial.println("Starting...");
//      irrecv.enableIRIn();
       Serial.println(TIMER_PWM_PIN);
  
delay(1000); 

}

void loop() {
  // put your main code here, to run repeatedly:

powergood=digitalRead(PG_PIN);
if (powergood!=pre_powergood) {
  pg_count[0]=0;
  pg_count[1]=0;
}

if (pg_count[powergood]<10) pg_count[powergood]++;
Serial.println(pg_count[powergood]);
if (pg_count[1]==3) { // HIGH
  turnOn();
  digitalWrite(2,HIGH); 
  delay(500);
  Serial.println("On");
}
 
if (pg_count[0]==3 ){           // LOW
  turnOff();
  digitalWrite(2,LOW);
  delay(500);
  Serial.println("Off");
}

pre_powergood=powergood;


if (irrecv.decode(&results)) {
    Serial.println(results.value, HEX);
    Serial.println(results.bits);
    Serial.print(" - ");
    switch (results.decode_type){
        case NEC: Serial.println("NEC"); break ;
        case SONY: Serial.println("SONY"); break ;
        case RC5: Serial.println("RC5"); break ;
        case RC6: Serial.println("RC6"); break ;
        case DISH: Serial.println("DISH"); break ;
        case SHARP: Serial.println("SHARP"); break ;
        case JVC: Serial.println("JVC"); break ;
        case SANYO: Serial.println("SANYO"); break ;
 //       case MITSUBISHI: Serial.println("MISUBISHI"); break ;
        case SAMSUNG: Serial.println("SAMSUNG"); break ;
        case LG: Serial.println("LG"); break ;
        case WHYNTER: Serial.println("WHYNTER"); break ;
 //       case AIWA_RC_T501: Serial.println("AIWARC_T501"); break ;
        case PANASONIC: Serial.println("PNASONIC"); break ;
        case DENON: Serial.println("DENON"); break ;
      default:
        case UNKNOWN: Serial.println("UNKNOWN"); break ;
      }
    irrecv.resume(); // Receive the next value
  }

}


void turnOn() {

  for (int i = 0; i < 3; i++) {

irsend.sendNEC(0x81CEE01F,32); // on
//irsend.sendSony(21516, 15); //15        
    delay(40);
  }

//digitalWrite(5, LOW);  

}

void turnOff() {

  for (int i = 0; i < 3; i++) {
    irsend.sendNEC(0x81CE906F,32); // standby
  //  irsend.sendSony(21516, 15);        
    delay(40);
  }
   Serial.println("Send...");

//digitalWrite(5, HIGH);  

//pinMode(TIMER_PWM_PIN,OUTPUT);
//digitalWrite(TIMER_PWM_PIN, LOW);

}
